import { ObserverCallback } from "./observable";
export default class AwaitStore<T = any> {
    private _value;
    private observable;
    constructor(_value: T);
    readonly value: T;
    send(value: T): void;
    subscribe(handler: ObserverCallback<T>): () => void;
    unsubscribe(handler: ObserverCallback<T>): void;
    awaitValue(val: T): PromiseLike<void> & {
        catch: (cb: (err: any) => PromiseLike<void>) => PromiseLike<void>;
        ignore: () => void;
    };
    /**
      * Creates Public API with subscribe and unsubscribe
      *
      * @returns {object}
      */
    getPublicApi(): {
        subscribe: (callback: ObserverCallback<T>) => () => void;
        unsubscribe: (callback: ObserverCallback<T>) => void;
        awaitValue: (value: T) => PromiseLike<void> & {
            catch: (cb: (err: any) => PromiseLike<void>) => PromiseLike<void>;
            ignore: () => void;
        };
    };
    close(): void;
}
